# Asset Builder Framework Workflow Tests:

Testing in this area focuses on the functionality of:
* Asset Builder Framework
  * Python Asset Builders
    * Python Bindings for Asset Builders
  * Python Integration into Source Scene Builders
* Asset Dependencies
  * Asset Source Dependencies
  * Asset Job Dependencies
  * Asset Product Dependencies

## Common Issues to Watch For:

Test guidance will sometimes note specific issues to watch for. The common issues below should be watched for through all testing, even if unrelated to the current workflow being tested.
1. Console log errors/warnings/spam 
2. Asserts 
3. Improperly rendered or assembled scenes 
4. HotReloading issues

### Common Terms:

###### Base Resources:
* [Asset Pipeline O3DE Resources](https://www.o3de.org/docs/user-guide/assets/pipeline/) <br>
* [Asset Pipeline Concepts and Terms](https://www.o3de.org/docs/user-guide/packaging/asset-bundler/concepts/) <br>
* [Asset Processor](https://www.o3de.org/docs/user-guide/assets/asset-processor/) <br> 
* [Asset Cache](https://www.o3de.org/docs/user-guide/assets/pipeline/asset-cache/) <br>

###### Builder Framework:
* [Asset Builder Framework](https://www.o3de.org/docs/user-guide/assets/pipeline/asset-builders/) <br>
  * [Python Asset Builders](https://www.o3de.org/docs/user-guide/assets/builder/) <br>
* [Scene Builder Framework](https://www.o3de.org/docs/user-guide/assets/scene-pipeline/scene-builder/) <br>
  * [Python Integration into Source Scene Builders - UDP](https://www.o3de.org/docs/user-guide/assets/scene-pipeline/scene-api-udp/#python-access) <br>

###### Asset Dependencies:
* [Source Dependencies](https://www.o3de.org/docs/user-guide/assets/pipeline/asset-dependencies-and-identifiers/#source-dependencies) <br>
* [Product Dependencies](https://www.o3de.org/docs/user-guide/assets/pipeline/asset-dependencies-and-identifiers/#product-dependencies) <br>
* [Job Dependencies](https://www.o3de.org/docs/user-guide/assets/pipeline/asset-dependencies-and-identifiers/#job-dependencies) <br>
 
---

## Feature: 

**Project Requirements:** 

**Resources:**

### Area: 

**Product:** 

**Suggested Time Box:** 

| Workflow | Requests | Things to Watch For |
|----------|----------|---------------------|
|          |          |                     |

---
